import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyEventOrchestrationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/event_orchestration#id DataPagerdutyEventOrchestration#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/event_orchestration#name DataPagerdutyEventOrchestration#name}
    */
    readonly name: string;
    /**
    * integration block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/event_orchestration#integration DataPagerdutyEventOrchestration#integration}
    */
    readonly integration?: DataPagerdutyEventOrchestrationIntegration[] | cdktf.IResolvable;
}
export interface DataPagerdutyEventOrchestrationIntegrationParameters {
}
export declare function dataPagerdutyEventOrchestrationIntegrationParametersToTerraform(struct?: DataPagerdutyEventOrchestrationIntegrationParameters): any;
export declare class DataPagerdutyEventOrchestrationIntegrationParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataPagerdutyEventOrchestrationIntegrationParameters | undefined;
    set internalValue(value: DataPagerdutyEventOrchestrationIntegrationParameters | undefined);
    get routingKey(): string;
    get type(): string;
}
export declare class DataPagerdutyEventOrchestrationIntegrationParametersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataPagerdutyEventOrchestrationIntegrationParametersOutputReference;
}
export interface DataPagerdutyEventOrchestrationIntegration {
}
export declare function dataPagerdutyEventOrchestrationIntegrationToTerraform(struct?: DataPagerdutyEventOrchestrationIntegration | cdktf.IResolvable): any;
export declare class DataPagerdutyEventOrchestrationIntegrationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataPagerdutyEventOrchestrationIntegration | cdktf.IResolvable | undefined;
    set internalValue(value: DataPagerdutyEventOrchestrationIntegration | cdktf.IResolvable | undefined);
    get id(): string;
    private _parameters;
    get parameters(): DataPagerdutyEventOrchestrationIntegrationParametersList;
}
export declare class DataPagerdutyEventOrchestrationIntegrationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataPagerdutyEventOrchestrationIntegration[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataPagerdutyEventOrchestrationIntegrationOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/d/event_orchestration pagerduty_event_orchestration}
*/
export declare class DataPagerdutyEventOrchestration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "pagerduty_event_orchestration";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/d/event_orchestration pagerduty_event_orchestration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyEventOrchestrationConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyEventOrchestrationConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _integration;
    get integration(): DataPagerdutyEventOrchestrationIntegrationList;
    putIntegration(value: DataPagerdutyEventOrchestrationIntegration[] | cdktf.IResolvable): void;
    resetIntegration(): void;
    get integrationInput(): cdktf.IResolvable | DataPagerdutyEventOrchestrationIntegration[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
