import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyTagConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/tag#id DataPagerdutyTag#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The label of the tag to find in the PagerDuty API
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/d/tag#label DataPagerdutyTag#label}
    */
    readonly label: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/d/tag pagerduty_tag}
*/
export declare class DataPagerdutyTag extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "pagerduty_tag";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/d/tag pagerduty_tag} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyTagConfig
    */
    constructor(scope: Construct, id: string, config: DataPagerdutyTagConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    get labelInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
