import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface TagConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/tag#id Tag#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/pagerduty/r/tag#label Tag#label}
    */
    readonly label: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/pagerduty/r/tag pagerduty_tag}
*/
export declare class Tag extends cdktf.TerraformResource {
    static readonly tfResourceType = "pagerduty_tag";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/pagerduty/r/tag pagerduty_tag} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options TagConfig
    */
    constructor(scope: Construct, id: string, config: TagConfig);
    get htmlUrl(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    get labelInput(): string | undefined;
    get summary(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
